unit View.PortalKunde.Edit;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls,

  Bcl.Rtti.Common, XData.Web.Client, Data.DB, WEBLib.CDS,
  WEBLib.DBCtrls, XData.Web.JsonDataset, XData.Web.Dataset, JS,

  App.Types, Crud.Utils, WEBLib.DB, WEBLib.Controls, WEBLib.ExtCtrls;

type
  TFViewPortalKundeEdit = class(TWebForm)
    pnlMessage: TWebPanel;
    lbMessage: TWebLabel;
    btCloseMessage: TWebButton;
    DataSource: TWebDatasource;
    btCancel: TWebButton;
    btSave: TWebButton;
    btDelete: TWebButton;
    lbKundeID: TWebLabel;
    edKundeID: TWebDBEdit;
    lbNummer: TWebLabel;
    edNummer: TWebDBEdit;
    lbVorname: TWebLabel;
    edVorname: TWebDBEdit;
    lbVorname2: TWebLabel;
    edVorname2: TWebDBEdit;
    lbNachname: TWebLabel;
    edNachname: TWebDBEdit;
    lbFirma: TWebLabel;
    edFirma: TWebDBEdit;
    lbFirmenname: TWebLabel;
    edFirmenname: TWebDBEdit;
    lbUStID: TWebLabel;
    edUStID: TWebDBEdit;
    lbStrasse: TWebLabel;
    edStrasse: TWebDBEdit;
    lbHausnummer: TWebLabel;
    edHausnummer: TWebDBEdit;
    lbZusatz: TWebLabel;
    edZusatz: TWebDBEdit;
    lbPLZ: TWebLabel;
    edPLZ: TWebDBEdit;
    lbOrt: TWebLabel;
    edOrt: TWebDBEdit;
    lbLand: TWebLabel;
    edLand: TWebDBEdit;
    lbEmail: TWebLabel;
    edEmail: TWebDBEdit;
    lbTelefon1: TWebLabel;
    edTelefon1: TWebDBEdit;
    lbTelefon2: TWebLabel;
    edTelefon2: TWebDBEdit;
    lbAusweis: TWebLabel;
    edAusweis: TWebDBEdit;
    lbAusweisTyp: TWebLabel;
    edAusweisTyp: TWebDBEdit;
    lbBehoerde: TWebLabel;
    edBehoerde: TWebDBEdit;
    lbHerkunft: TWebLabel;
    edHerkunft: TWebDBEdit;
    lbKontoinhaber: TWebLabel;
    edKontoinhaber: TWebDBEdit;
    lbIBAN: TWebLabel;
    edIBAN: TWebDBEdit;
    lbBIC: TWebLabel;
    edBIC: TWebDBEdit;
    lbsngCreate: TWebLabel;
    edsngCreate: TWebDBEdit;
    lbsngCreateUser: TWebLabel;
    edsngCreateUser: TWebDBEdit;
    lbsngChange: TWebLabel;
    edsngChange: TWebDBEdit;
    lbsngChangeUser: TWebLabel;
    edsngChangeUser: TWebDBEdit;
    XDataClientPortalKundeGet: TXDataWebClient;
    XDataClientPortalKundeDelete: TXDataWebClient;
    PortalKundeDataset: TXDataWebDataSet;
    PortalKundeDatasetKundeID: TStringField;
    PortalKundeDatasetNummer: TStringField;
    PortalKundeDatasetVorname: TStringField;
    PortalKundeDatasetVorname2: TStringField;
    PortalKundeDatasetNachname: TStringField;
    PortalKundeDatasetFirma: TBooleanField;
    PortalKundeDatasetFirmenname: TStringField;
    PortalKundeDatasetUStID: TStringField;
    PortalKundeDatasetStrasse: TStringField;
    PortalKundeDatasetHausnummer: TStringField;
    PortalKundeDatasetZusatz: TStringField;
    PortalKundeDatasetPLZ: TStringField;
    PortalKundeDatasetOrt: TStringField;
    PortalKundeDatasetLand: TStringField;
    PortalKundeDatasetEmail: TStringField;
    PortalKundeDatasetTelefon1: TStringField;
    PortalKundeDatasetTelefon2: TStringField;
    PortalKundeDatasetAusweis: TStringField;
    PortalKundeDatasetAusweisTyp: TStringField;
    PortalKundeDatasetBehoerde: TStringField;
    PortalKundeDatasetHerkunft: TStringField;
    PortalKundeDatasetKontoinhaber: TStringField;
    PortalKundeDatasetIBAN: TStringField;
    PortalKundeDatasetBIC: TStringField;
    PortalKundeDatasetsngCreate: TDateTimeField;
    PortalKundeDatasetsngCreateUser: TStringField;
    PortalKundeDatasetsngChange: TDateTimeField;
    PortalKundeDatasetsngChangeUser: TStringField;
    procedure btCloseMessageClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure XDataClientPortalKundeGetLoad(Response: TXDataClientResponse);
    procedure XDataClientPortalKundeDeleteLoad(Response: TXDataClientResponse);
    procedure XDataClientPortalKundeDeleteError(Error: TXDataClientError);
    procedure PortalKundeDatasetAfterApplyUpdates(Sender: TDataSet;
      Info: TResolveResults);
    procedure WebFormCreate(Sender: TObject);
  private
    FId: JSValue;
    FShowListProc: TListProc;
    procedure InsertEntity;
    procedure LoadEntity;
    procedure ShowNotification(Notification: string);
    procedure HiddenNotification;
    class function InternalCreateForm(AElementID: string;
      AShowListProc: TListProc; AInserting: Boolean; AId: JSValue): TWebForm; overload;
  protected
    FInserting: Boolean;
  public
    class function CreateForm(AElementID: string;
      AShowListProc: TListProc; AId: JSValue): TWebForm; overload;
  end;

var
  FViewPortalKundeEdit: TFViewPortalKundeEdit;

implementation

uses
  ConnectionModule;

{$R *.dfm}

{ TFViewPortalKundeEdit }

procedure TFViewPortalKundeEdit.btSaveClick(Sender: TObject);
begin
  if PortalKundeDataset.State in dsEditModes then
  begin
        PortalKundeDataset.Post;
    PortalKundeDataset.ApplyUpdates;
  end
  else
    FShowListProc;
end;

procedure TFViewPortalKundeEdit.btDeleteClick(Sender: TObject);
begin
  if PortalKundeDataset.State in dsEditModes then
    PortalKundeDataset.Post;
  XDataClientPortalKundeDelete.Delete(PortalKundeDataset.EntitySetName,
    TJSObject(PortalKundeDataset.CurrentData));
end;


class function TFViewPortalKundeEdit.CreateForm(AElementID: string;
  AShowListProc: TListProc; AId: JSValue): TWebForm;
var
  Inserting: Boolean;
begin
  Inserting := isNull(AId);
  Result := InternalCreateForm(AElementID, AShowListProc, Inserting, AId);
end;

procedure TFViewPortalKundeEdit.HiddenNotification;
begin
  pnlMessage.ElementHandle.hidden := True;
end;

procedure TFViewPortalKundeEdit.InsertEntity;
begin
  PortalKundeDataset.Close;
  PortalKundeDataset.SetJsonData('{}');
  PortalKundeDataset.Open;
  PortalKundeDataset.Insert;
end;

class function TFViewPortalKundeEdit.InternalCreateForm(AElementID: string;
  AShowListProc: TListProc; AInserting: Boolean; AId: JSValue): TWebForm;

  procedure AfterCreate(AForm: TObject);
  begin
    TFViewPortalKundeEdit(AForm).FInserting := AInserting;
    TFViewPortalKundeEdit(AForm).FId := AId;
    TFViewPortalKundeEdit(AForm).FShowListProc := AShowListProc;
    if AInserting then
      TFViewPortalKundeEdit(AForm).InsertEntity
    else
      TFViewPortalKundeEdit(AForm).LoadEntity;
    TFViewPortalKundeEdit(AForm).btDelete.Enabled := not AInserting;
  end;

begin
  Application.CreateForm(TFViewPortalKundeEdit, AElementID, Result, @AfterCreate);
end;

procedure TFViewPortalKundeEdit.LoadEntity;
var
  QueryString: string;
begin
  QueryString := TCrudUtils.GetEntityGetQueryString(
    PortalKundeDataset.Connection.Model.DefaultSchema.FindEntityType(
      PortalKundeDataset.EntitySetName
    )
  );
  XDataClientPortalKundeGet.Get(PortalKundeDataset.EntitySetName, QueryString, FId);
end;

procedure TFViewPortalKundeEdit.ShowNotification(Notification: string);
begin
  lbMessage.Caption := Notification;
  pnlMessage.ElementHandle.hidden := False;
end;

procedure TFViewPortalKundeEdit.btCloseMessageClick(Sender: TObject);
begin
  HiddenNotification;
end;

procedure TFViewPortalKundeEdit.WebFormCreate(Sender: TObject);
begin
  HiddenNotification;
end;

procedure TFViewPortalKundeEdit.XDataClientPortalKundeGetLoad(Response: TXDataClientResponse);
begin
  PortalKundeDataset.Close;
  PortalKundeDataset.SetJsonData(Response.Result);
  PortalKundeDataset.Open;
  
  PortalKundeDataset.Edit;  
end;

procedure TFViewPortalKundeEdit.XDataClientPortalKundeDeleteError(
  Error: TXDataClientError);
begin
  ShowNotification(Error.ErrorMessage);
end;

procedure TFViewPortalKundeEdit.XDataClientPortalKundeDeleteLoad(
  Response: TXDataClientResponse);
begin
  FShowListProc;
end;

procedure TFViewPortalKundeEdit.PortalKundeDatasetAfterApplyUpdates(Sender: TDataSet;
  Info: TResolveResults);
var
  I: integer;
  ResolveInfo: TResolveInfo;
begin
  for I := 0 to Length(Info.Records) - 1 do
  begin
    ResolveInfo := Info.Records[I];
//    if ResolveInfo.ResolveStatus = TResolveStatus.rsResolveFailed then
    if ResolveInfo.Error <> '' then
    begin
      ShowNotification(ResolveInfo.Error);
      Exit;
    end;
  end;
  FShowListProc;
end;

procedure TFViewPortalKundeEdit.btCancelClick(Sender: TObject);
begin
  FShowListProc;
end;

end.
