unit View.PortalKunde.List;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.Controls, Vcl.StdCtrls, Math,

  WEBLib.StdCtrls, Web, JS, WEBLib.Lists,

  App.Types, WEBLib.Controls, WEBLib.Grids, Data.DB,
  XData.Web.Dataset, WEBLib.DBCtrls, WEBLib.DB, WEBLib.ExtCtrls,

  XData.Web.JsonDataset,

  Grid.Plugins,
  Crud.Utils;

type
  TFViewPortalKundeList = class(TWebForm)
    btNew: TWebButton;
    PortalKundeDataset: TXDataWebDataSet;
    PortalKundeDatasetKundeID: TStringField;
    PortalKundeDatasetNummer: TStringField;
    PortalKundeDatasetVorname: TStringField;
    PortalKundeDatasetVorname2: TStringField;
    PortalKundeDatasetNachname: TStringField;
    PortalKundeDatasetFirma: TBooleanField;
    PortalKundeDatasetFirmenname: TStringField;
    PortalKundeDatasetUStID: TStringField;
    PortalKundeDatasetStrasse: TStringField;
    PortalKundeDatasetHausnummer: TStringField;
    PortalKundeDatasetZusatz: TStringField;
    PortalKundeDatasetPLZ: TStringField;
    PortalKundeDatasetOrt: TStringField;
    PortalKundeDatasetLand: TStringField;
    PortalKundeDatasetEmail: TStringField;
    PortalKundeDatasetTelefon1: TStringField;
    PortalKundeDatasetTelefon2: TStringField;
    PortalKundeDatasetAusweis: TStringField;
    PortalKundeDatasetAusweisTyp: TStringField;
    PortalKundeDatasetBehoerde: TStringField;
    PortalKundeDatasetHerkunft: TStringField;
    PortalKundeDatasetKontoinhaber: TStringField;
    PortalKundeDatasetIBAN: TStringField;
    PortalKundeDatasetBIC: TStringField;
    PortalKundeDatasetsngCreate: TDateTimeField;
    PortalKundeDatasetsngCreateUser: TStringField;
    PortalKundeDatasetsngChange: TDateTimeField;
    PortalKundeDatasetsngChangeUser: TStringField;
    WebDBTableControl1: TWebDBTableControl;
    WebDataSource: TWebDataSource;
    cbPageSize: TWebComboBox;
    edSearch: TWebEdit;
    lbPaginationInfo: TWebLabel;
    lcPaginator: TWebListControl;
    procedure WebFormCreate(Sender: TObject);
    procedure btNewClick(Sender: TObject);
    procedure WebDBTableControl1GetCellChildren(Sender: TObject; ACol,
      ARow: Integer; AField: TField; AValue: string; AElement: TJSHTMLElementRecord);
    procedure cbPageSizeChange(Sender: TObject);
    procedure edSearchChange(Sender: TObject);
  private
    FEditProc: TEditProc;
    FGridPlugin: TGridPlugin;
  public
    class function CreateForm(AElementID: string; AShowEditProc: TEditProc): TWebForm;
  end;

var
  FViewPortalKundeList: TFViewPortalKundeList;

implementation

uses
  ConnectionModule;

{$R *.dfm}

{ TFViewPortalKundeList }

procedure TFViewPortalKundeList.cbPageSizeChange(Sender: TObject);
begin
  FGridPlugin.SetPageSize(StrToInt(cbPageSize.Text), True);
end;

class function TFViewPortalKundeList.CreateForm(AElementID: string;
  AShowEditProc: TEditProc): TWebForm;

  procedure AfterCreate(AForm: TObject);
  begin
    TFViewPortalKundeList(AForm).FEditProc := AShowEditProc;
  end;

begin
  Application.CreateForm(TFViewPortalKundeList, AElementID, Result, @AfterCreate);
end;

procedure TFViewPortalKundeList.edSearchChange(Sender: TObject);
begin
  FGridPlugin.SetFilterText(edSearch.Text, True);
end;

procedure TFViewPortalKundeList.btNewClick(Sender: TObject);
begin
  FEditProc( nil );
end;

procedure TFViewPortalKundeList.WebDBTableControl1GetCellChildren(Sender: TObject;
  ACol, ARow: Integer; AField: TField; AValue: string;
  AElement: TJSHTMLElementRecord);
var
  RecordId: JSValue;

  procedure EditButtonClick(Sender: TObject);
  begin
    FEditProc(RecordId);
  end;

var
  Button: TWebButton;
begin
  if ARow = 0 then
    Exit;

  if WebDBTableControl1.Columns[ACol].Title = 'Actions' then
  begin
    RecordId := TCrudUtils.GetIdFromObject(
      PortalKundeDataset.Connection.Model.DefaultSchema.FindEntityType(PortalKundeDataset.EntitySetName),
      PortalKundeDataset.CurrentData
    );
    Button := TWebButton.Create(nil);
    Button.Caption := 'Edit';
    Button.OnClick := @EditButtonClick;
    Button.ElementClassName := 'btn btn-outline btn-default btn-xs';
    Button.ParentElement := AElement.element;
    Button.WidthStyle := TSizeStyle.ssAuto;
    Button.HeightStyle := TSizeStyle.ssAuto;
  end;
end;

procedure TFViewPortalKundeList.WebFormCreate(Sender: TObject);
begin
  FGridPlugin := TGridPlugin.Create(
    WebDBTableControl1,
    PortalKundeDataset,
    lcPaginator,
    lbPaginationInfo
  );
  FGridPlugin.SetPageSize(StrToInt(cbPageSize.Text));
  FGridPlugin.SetFilterText(edSearch.Text);
  FGridPlugin.Load;
end;

end.
