unit View.PortalKundeNachrichten.Edit;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls,

  Bcl.Rtti.Common, XData.Web.Client, Data.DB, WEBLib.CDS,
  WEBLib.DBCtrls, XData.Web.JsonDataset, XData.Web.Dataset, JS,

  App.Types, Crud.Utils, WEBLib.DB, WEBLib.Controls, WEBLib.ExtCtrls;

type
  TFViewPortalKundeNachrichtenEdit = class(TWebForm)
    pnlMessage: TWebPanel;
    lbMessage: TWebLabel;
    btCloseMessage: TWebButton;
    DataSource: TWebDatasource;
    btCancel: TWebButton;
    btSave: TWebButton;
    btDelete: TWebButton;
    lbKundeNachrichtenID: TWebLabel;
    edKundeNachrichtenID: TWebDBEdit;
    lbGelesen: TWebLabel;
    edGelesen: TWebDBEdit;
    lbsngCreate: TWebLabel;
    edsngCreate: TWebDBEdit;
    lbsngCreateUser: TWebLabel;
    edsngCreateUser: TWebDBEdit;
    lbsngChange: TWebLabel;
    edsngChange: TWebDBEdit;
    lbsngChangeUser: TWebLabel;
    edsngChangeUser: TWebDBEdit;
    lbNachricht: TWebLabel;
    cbNachricht: TWebComboBox;
    lbKunde: TWebLabel;
    cbKunde: TWebComboBox;
    XDataClientPortalKundeNachrichtenGet: TXDataWebClient;
    XDataClientPortalKundeNachrichtenDelete: TXDataWebClient;
    PortalKundeNachrichtenDataset: TXDataWebDataSet;
    PortalKundeNachrichtenDatasetKundeNachrichtenID: TStringField;
    PortalKundeNachrichtenDatasetGelesen: TDateTimeField;
    PortalKundeNachrichtenDatasetsngCreate: TDateTimeField;
    PortalKundeNachrichtenDatasetsngCreateUser: TStringField;
    PortalKundeNachrichtenDatasetsngChange: TDateTimeField;
    PortalKundeNachrichtenDatasetsngChangeUser: TStringField;
    PortalKundeNachrichtenDatasetNachricht: TXDataWebEntityField;
    PortalKundeNachrichtenDatasetKunde: TXDataWebEntityField;
    NachrichtDataset: TXDataWebDataSet;
    NachrichtDatasetNachrichtID: TStringField;
    NachrichtDatasetStatus: TStringField;
    NachrichtDatasetDatum: TDateTimeField;
    NachrichtDatasetTitel: TStringField;
    NachrichtDatasetText: TStringField;
    NachrichtDatasetsngCreate: TDateTimeField;
    NachrichtDatasetsngCreateUser: TStringField;
    NachrichtDatasetsngChange: TDateTimeField;
    NachrichtDatasetsngChangeUser: TStringField;
    KundeDataset: TXDataWebDataSet;
    KundeDatasetKundeID: TStringField;
    KundeDatasetNummer: TStringField;
    KundeDatasetVorname: TStringField;
    KundeDatasetVorname2: TStringField;
    KundeDatasetNachname: TStringField;
    KundeDatasetFirma: TBooleanField;
    KundeDatasetFirmenname: TStringField;
    KundeDatasetUStID: TStringField;
    KundeDatasetStrasse: TStringField;
    KundeDatasetHausnummer: TStringField;
    KundeDatasetZusatz: TStringField;
    KundeDatasetPLZ: TStringField;
    KundeDatasetOrt: TStringField;
    KundeDatasetLand: TStringField;
    KundeDatasetEmail: TStringField;
    KundeDatasetTelefon1: TStringField;
    KundeDatasetTelefon2: TStringField;
    KundeDatasetAusweis: TStringField;
    KundeDatasetAusweisTyp: TStringField;
    KundeDatasetBehoerde: TStringField;
    KundeDatasetHerkunft: TStringField;
    KundeDatasetKontoinhaber: TStringField;
    KundeDatasetIBAN: TStringField;
    KundeDatasetBIC: TStringField;
    KundeDatasetsngCreate: TDateTimeField;
    KundeDatasetsngCreateUser: TStringField;
    KundeDatasetsngChange: TDateTimeField;
    KundeDatasetsngChangeUser: TStringField;
    procedure btCloseMessageClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure XDataClientPortalKundeNachrichtenGetLoad(Response: TXDataClientResponse);
    procedure XDataClientPortalKundeNachrichtenDeleteLoad(Response: TXDataClientResponse);
    procedure XDataClientPortalKundeNachrichtenDeleteError(Error: TXDataClientError);
    procedure PortalKundeNachrichtenDatasetAfterApplyUpdates(Sender: TDataSet;
      Info: TResolveResults);
    procedure WebFormCreate(Sender: TObject);
    procedure NachrichtDatasetAfterOpen(DataSet: TDataSet);
    procedure KundeDatasetAfterOpen(DataSet: TDataSet);
  private
    FId: JSValue;
    FShowListProc: TListProc;
    procedure InsertEntity;
    procedure LoadEntity;
    procedure ShowNotification(Notification: string);
    procedure HiddenNotification;
    class function InternalCreateForm(AElementID: string;
      AShowListProc: TListProc; AInserting: Boolean; AId: JSValue): TWebForm; overload;
  protected
    FInserting: Boolean;
  public
    class function CreateForm(AElementID: string;
      AShowListProc: TListProc; AId: JSValue): TWebForm; overload;
  end;

var
  FViewPortalKundeNachrichtenEdit: TFViewPortalKundeNachrichtenEdit;

implementation

uses
  ConnectionModule;

{$R *.dfm}

{ TFViewPortalKundeNachrichtenEdit }

procedure TFViewPortalKundeNachrichtenEdit.btSaveClick(Sender: TObject);
begin
  if PortalKundeNachrichtenDataset.State in dsEditModes then
  begin
        PortalKundeNachrichtenDatasetNachricht.Value := cbNachricht.Items.Objects[cbNachricht.ItemIndex];
    PortalKundeNachrichtenDatasetKunde.Value := cbKunde.Items.Objects[cbKunde.ItemIndex];
    PortalKundeNachrichtenDataset.Post;
    PortalKundeNachrichtenDataset.ApplyUpdates;
  end
  else
    FShowListProc;
end;

procedure TFViewPortalKundeNachrichtenEdit.btDeleteClick(Sender: TObject);
begin
  if PortalKundeNachrichtenDataset.State in dsEditModes then
    PortalKundeNachrichtenDataset.Post;
  XDataClientPortalKundeNachrichtenDelete.Delete(PortalKundeNachrichtenDataset.EntitySetName,
    TJSObject(PortalKundeNachrichtenDataset.CurrentData));
end;


class function TFViewPortalKundeNachrichtenEdit.CreateForm(AElementID: string;
  AShowListProc: TListProc; AId: JSValue): TWebForm;
var
  Inserting: Boolean;
begin
  Inserting := isNull(AId);
  Result := InternalCreateForm(AElementID, AShowListProc, Inserting, AId);
end;

procedure TFViewPortalKundeNachrichtenEdit.HiddenNotification;
begin
  pnlMessage.ElementHandle.hidden := True;
end;

procedure TFViewPortalKundeNachrichtenEdit.InsertEntity;
begin
  PortalKundeNachrichtenDataset.Close;
  PortalKundeNachrichtenDataset.SetJsonData('{}');
  PortalKundeNachrichtenDataset.Open;
  PortalKundeNachrichtenDataset.Insert;
  TCrudUtils.LoadAssociationDataset(NachrichtDataset, 'Status');
  TCrudUtils.LoadAssociationDataset(KundeDataset, 'Nummer');
end;

class function TFViewPortalKundeNachrichtenEdit.InternalCreateForm(AElementID: string;
  AShowListProc: TListProc; AInserting: Boolean; AId: JSValue): TWebForm;

  procedure AfterCreate(AForm: TObject);
  begin
    TFViewPortalKundeNachrichtenEdit(AForm).FInserting := AInserting;
    TFViewPortalKundeNachrichtenEdit(AForm).FId := AId;
    TFViewPortalKundeNachrichtenEdit(AForm).FShowListProc := AShowListProc;
    if AInserting then
      TFViewPortalKundeNachrichtenEdit(AForm).InsertEntity
    else
      TFViewPortalKundeNachrichtenEdit(AForm).LoadEntity;
    TFViewPortalKundeNachrichtenEdit(AForm).btDelete.Enabled := not AInserting;
  end;

begin
  Application.CreateForm(TFViewPortalKundeNachrichtenEdit, AElementID, Result, @AfterCreate);
end;

procedure TFViewPortalKundeNachrichtenEdit.LoadEntity;
var
  QueryString: string;
begin
  QueryString := TCrudUtils.GetEntityGetQueryString(
    PortalKundeNachrichtenDataset.Connection.Model.DefaultSchema.FindEntityType(
      PortalKundeNachrichtenDataset.EntitySetName
    )
  );
  XDataClientPortalKundeNachrichtenGet.Get(PortalKundeNachrichtenDataset.EntitySetName, QueryString, FId);
end;

procedure TFViewPortalKundeNachrichtenEdit.ShowNotification(Notification: string);
begin
  lbMessage.Caption := Notification;
  pnlMessage.ElementHandle.hidden := False;
end;

procedure TFViewPortalKundeNachrichtenEdit.btCloseMessageClick(Sender: TObject);
begin
  HiddenNotification;
end;

procedure TFViewPortalKundeNachrichtenEdit.WebFormCreate(Sender: TObject);
begin
  HiddenNotification;
end;

procedure TFViewPortalKundeNachrichtenEdit.XDataClientPortalKundeNachrichtenGetLoad(Response: TXDataClientResponse);
begin
  PortalKundeNachrichtenDataset.Close;
  PortalKundeNachrichtenDataset.SetJsonData(Response.Result);
  PortalKundeNachrichtenDataset.Open;
  
  PortalKundeNachrichtenDataset.Edit;  
  TCrudUtils.LoadAssociationDataset(NachrichtDataset, 'Status');
  TCrudUtils.LoadAssociationDataset(KundeDataset, 'Nummer');
end;

procedure TFViewPortalKundeNachrichtenEdit.XDataClientPortalKundeNachrichtenDeleteError(
  Error: TXDataClientError);
begin
  ShowNotification(Error.ErrorMessage);
end;

procedure TFViewPortalKundeNachrichtenEdit.XDataClientPortalKundeNachrichtenDeleteLoad(
  Response: TXDataClientResponse);
begin
  FShowListProc;
end;

procedure TFViewPortalKundeNachrichtenEdit.PortalKundeNachrichtenDatasetAfterApplyUpdates(Sender: TDataSet;
  Info: TResolveResults);
var
  I: integer;
  ResolveInfo: TResolveInfo;
begin
  for I := 0 to Length(Info.Records) - 1 do
  begin
    ResolveInfo := Info.Records[I];
//    if ResolveInfo.ResolveStatus = TResolveStatus.rsResolveFailed then
    if ResolveInfo.Error <> '' then
    begin
      ShowNotification(ResolveInfo.Error);
      Exit;
    end;
  end;
  FShowListProc;
end;

procedure TFViewPortalKundeNachrichtenEdit.btCancelClick(Sender: TObject);
begin
  FShowListProc;
end;

procedure TFViewPortalKundeNachrichtenEdit.NachrichtDatasetAfterOpen(DataSet: TDataSet);
begin
  TCrudUtils.PopulateAssociationCombobox(cbNachricht,
    TXDataWebDataSet(DataSet), 'Status');

  if FInserting then
    cbNachricht.ItemIndex := -1
  else
  begin
    TCrudUtils.SelectAssociationItem(cbNachricht, PortalKundeNachrichtenDatasetNachricht);
  end;
end;

procedure TFViewPortalKundeNachrichtenEdit.KundeDatasetAfterOpen(DataSet: TDataSet);
begin
  TCrudUtils.PopulateAssociationCombobox(cbKunde,
    TXDataWebDataSet(DataSet), 'Nummer');

  if FInserting then
    cbKunde.ItemIndex := -1
  else
  begin
    TCrudUtils.SelectAssociationItem(cbKunde, PortalKundeNachrichtenDatasetKunde);
  end;
end;

end.
