unit View.PortalNachrichten.Edit;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls,

  Bcl.Rtti.Common, XData.Web.Client, Data.DB, WEBLib.CDS,
  WEBLib.DBCtrls, XData.Web.JsonDataset, XData.Web.Dataset, JS,

  App.Types, Crud.Utils, WEBLib.DB, WEBLib.Controls, WEBLib.ExtCtrls;

type
  TFViewPortalNachrichtenEdit = class(TWebForm)
    pnlMessage: TWebPanel;
    lbMessage: TWebLabel;
    btCloseMessage: TWebButton;
    DataSource: TWebDatasource;
    btCancel: TWebButton;
    btSave: TWebButton;
    btDelete: TWebButton;
    lbNachrichtID: TWebLabel;
    edNachrichtID: TWebDBEdit;
    lbStatus: TWebLabel;
    edStatus: TWebDBEdit;
    lbDatum: TWebLabel;
    edDatum: TWebDBEdit;
    lbTitel: TWebLabel;
    edTitel: TWebDBEdit;
    lbText: TWebLabel;
    edText: TWebDBEdit;
    lbsngCreate: TWebLabel;
    edsngCreate: TWebDBEdit;
    lbsngCreateUser: TWebLabel;
    edsngCreateUser: TWebDBEdit;
    lbsngChange: TWebLabel;
    edsngChange: TWebDBEdit;
    lbsngChangeUser: TWebLabel;
    edsngChangeUser: TWebDBEdit;
    XDataClientPortalNachrichtenGet: TXDataWebClient;
    XDataClientPortalNachrichtenDelete: TXDataWebClient;
    PortalNachrichtenDataset: TXDataWebDataSet;
    PortalNachrichtenDatasetNachrichtID: TStringField;
    PortalNachrichtenDatasetStatus: TStringField;
    PortalNachrichtenDatasetDatum: TDateTimeField;
    PortalNachrichtenDatasetTitel: TStringField;
    PortalNachrichtenDatasetText: TStringField;
    PortalNachrichtenDatasetsngCreate: TDateTimeField;
    PortalNachrichtenDatasetsngCreateUser: TStringField;
    PortalNachrichtenDatasetsngChange: TDateTimeField;
    PortalNachrichtenDatasetsngChangeUser: TStringField;
    procedure btCloseMessageClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure XDataClientPortalNachrichtenGetLoad(Response: TXDataClientResponse);
    procedure XDataClientPortalNachrichtenDeleteLoad(Response: TXDataClientResponse);
    procedure XDataClientPortalNachrichtenDeleteError(Error: TXDataClientError);
    procedure PortalNachrichtenDatasetAfterApplyUpdates(Sender: TDataSet;
      Info: TResolveResults);
    procedure WebFormCreate(Sender: TObject);
  private
    FId: JSValue;
    FShowListProc: TListProc;
    procedure InsertEntity;
    procedure LoadEntity;
    procedure ShowNotification(Notification: string);
    procedure HiddenNotification;
    class function InternalCreateForm(AElementID: string;
      AShowListProc: TListProc; AInserting: Boolean; AId: JSValue): TWebForm; overload;
  protected
    FInserting: Boolean;
  public
    class function CreateForm(AElementID: string;
      AShowListProc: TListProc; AId: JSValue): TWebForm; overload;
  end;

var
  FViewPortalNachrichtenEdit: TFViewPortalNachrichtenEdit;

implementation

uses
  ConnectionModule;

{$R *.dfm}

{ TFViewPortalNachrichtenEdit }

procedure TFViewPortalNachrichtenEdit.btSaveClick(Sender: TObject);
begin
  if PortalNachrichtenDataset.State in dsEditModes then
  begin
        PortalNachrichtenDataset.Post;
    PortalNachrichtenDataset.ApplyUpdates;
  end
  else
    FShowListProc;
end;

procedure TFViewPortalNachrichtenEdit.btDeleteClick(Sender: TObject);
begin
  if PortalNachrichtenDataset.State in dsEditModes then
    PortalNachrichtenDataset.Post;
  XDataClientPortalNachrichtenDelete.Delete(PortalNachrichtenDataset.EntitySetName,
    TJSObject(PortalNachrichtenDataset.CurrentData));
end;


class function TFViewPortalNachrichtenEdit.CreateForm(AElementID: string;
  AShowListProc: TListProc; AId: JSValue): TWebForm;
var
  Inserting: Boolean;
begin
  Inserting := isNull(AId);
  Result := InternalCreateForm(AElementID, AShowListProc, Inserting, AId);
end;

procedure TFViewPortalNachrichtenEdit.HiddenNotification;
begin
  pnlMessage.ElementHandle.hidden := True;
end;

procedure TFViewPortalNachrichtenEdit.InsertEntity;
begin
  PortalNachrichtenDataset.Close;
  PortalNachrichtenDataset.SetJsonData('{}');
  PortalNachrichtenDataset.Open;
  PortalNachrichtenDataset.Insert;
end;

class function TFViewPortalNachrichtenEdit.InternalCreateForm(AElementID: string;
  AShowListProc: TListProc; AInserting: Boolean; AId: JSValue): TWebForm;

  procedure AfterCreate(AForm: TObject);
  begin
    TFViewPortalNachrichtenEdit(AForm).FInserting := AInserting;
    TFViewPortalNachrichtenEdit(AForm).FId := AId;
    TFViewPortalNachrichtenEdit(AForm).FShowListProc := AShowListProc;
    if AInserting then
      TFViewPortalNachrichtenEdit(AForm).InsertEntity
    else
      TFViewPortalNachrichtenEdit(AForm).LoadEntity;
    TFViewPortalNachrichtenEdit(AForm).btDelete.Enabled := not AInserting;
  end;

begin
  Application.CreateForm(TFViewPortalNachrichtenEdit, AElementID, Result, @AfterCreate);
end;

procedure TFViewPortalNachrichtenEdit.LoadEntity;
var
  QueryString: string;
begin
  QueryString := TCrudUtils.GetEntityGetQueryString(
    PortalNachrichtenDataset.Connection.Model.DefaultSchema.FindEntityType(
      PortalNachrichtenDataset.EntitySetName
    )
  );
  XDataClientPortalNachrichtenGet.Get(PortalNachrichtenDataset.EntitySetName, QueryString, FId);
end;

procedure TFViewPortalNachrichtenEdit.ShowNotification(Notification: string);
begin
  lbMessage.Caption := Notification;
  pnlMessage.ElementHandle.hidden := False;
end;

procedure TFViewPortalNachrichtenEdit.btCloseMessageClick(Sender: TObject);
begin
  HiddenNotification;
end;

procedure TFViewPortalNachrichtenEdit.WebFormCreate(Sender: TObject);
begin
  HiddenNotification;
end;

procedure TFViewPortalNachrichtenEdit.XDataClientPortalNachrichtenGetLoad(Response: TXDataClientResponse);
begin
  PortalNachrichtenDataset.Close;
  PortalNachrichtenDataset.SetJsonData(Response.Result);
  PortalNachrichtenDataset.Open;
  
  PortalNachrichtenDataset.Edit;  
end;

procedure TFViewPortalNachrichtenEdit.XDataClientPortalNachrichtenDeleteError(
  Error: TXDataClientError);
begin
  ShowNotification(Error.ErrorMessage);
end;

procedure TFViewPortalNachrichtenEdit.XDataClientPortalNachrichtenDeleteLoad(
  Response: TXDataClientResponse);
begin
  FShowListProc;
end;

procedure TFViewPortalNachrichtenEdit.PortalNachrichtenDatasetAfterApplyUpdates(Sender: TDataSet;
  Info: TResolveResults);
var
  I: integer;
  ResolveInfo: TResolveInfo;
begin
  for I := 0 to Length(Info.Records) - 1 do
  begin
    ResolveInfo := Info.Records[I];
//    if ResolveInfo.ResolveStatus = TResolveStatus.rsResolveFailed then
    if ResolveInfo.Error <> '' then
    begin
      ShowNotification(ResolveInfo.Error);
      Exit;
    end;
  end;
  FShowListProc;
end;

procedure TFViewPortalNachrichtenEdit.btCancelClick(Sender: TObject);
begin
  FShowListProc;
end;

end.
