unit View.PortalNachrichten.List;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.Controls, Vcl.StdCtrls, Math,

  WEBLib.StdCtrls, Web, JS, WEBLib.Lists,

  App.Types, WEBLib.Controls, WEBLib.Grids, Data.DB,
  XData.Web.Dataset, WEBLib.DBCtrls, WEBLib.DB, WEBLib.ExtCtrls,

  XData.Web.JsonDataset,

  Grid.Plugins,
  Crud.Utils;

type
  TFViewPortalNachrichtenList = class(TWebForm)
    btNew: TWebButton;
    PortalNachrichtenDataset: TXDataWebDataSet;
    PortalNachrichtenDatasetNachrichtID: TStringField;
    PortalNachrichtenDatasetStatus: TStringField;
    PortalNachrichtenDatasetDatum: TDateTimeField;
    PortalNachrichtenDatasetTitel: TStringField;
    PortalNachrichtenDatasetText: TStringField;
    PortalNachrichtenDatasetsngCreate: TDateTimeField;
    PortalNachrichtenDatasetsngCreateUser: TStringField;
    PortalNachrichtenDatasetsngChange: TDateTimeField;
    PortalNachrichtenDatasetsngChangeUser: TStringField;
    WebDBTableControl1: TWebDBTableControl;
    WebDataSource: TWebDataSource;
    cbPageSize: TWebComboBox;
    edSearch: TWebEdit;
    lbPaginationInfo: TWebLabel;
    lcPaginator: TWebListControl;
    procedure WebFormCreate(Sender: TObject);
    procedure btNewClick(Sender: TObject);
    procedure WebDBTableControl1GetCellChildren(Sender: TObject; ACol,
      ARow: Integer; AField: TField; AValue: string; AElement: TJSHTMLElementRecord);
    procedure cbPageSizeChange(Sender: TObject);
    procedure edSearchChange(Sender: TObject);
  private
    FEditProc: TEditProc;
    FGridPlugin: TGridPlugin;
  public
    class function CreateForm(AElementID: string; AShowEditProc: TEditProc): TWebForm;
  end;

var
  FViewPortalNachrichtenList: TFViewPortalNachrichtenList;

implementation

uses
  ConnectionModule;

{$R *.dfm}

{ TFViewPortalNachrichtenList }

procedure TFViewPortalNachrichtenList.cbPageSizeChange(Sender: TObject);
begin
  FGridPlugin.SetPageSize(StrToInt(cbPageSize.Text), True);
end;

class function TFViewPortalNachrichtenList.CreateForm(AElementID: string;
  AShowEditProc: TEditProc): TWebForm;

  procedure AfterCreate(AForm: TObject);
  begin
    TFViewPortalNachrichtenList(AForm).FEditProc := AShowEditProc;
  end;

begin
  Application.CreateForm(TFViewPortalNachrichtenList, AElementID, Result, @AfterCreate);
end;

procedure TFViewPortalNachrichtenList.edSearchChange(Sender: TObject);
begin
  FGridPlugin.SetFilterText(edSearch.Text, True);
end;

procedure TFViewPortalNachrichtenList.btNewClick(Sender: TObject);
begin
  FEditProc( nil );
end;

procedure TFViewPortalNachrichtenList.WebDBTableControl1GetCellChildren(Sender: TObject;
  ACol, ARow: Integer; AField: TField; AValue: string;
  AElement: TJSHTMLElementRecord);
var
  RecordId: JSValue;

  procedure EditButtonClick(Sender: TObject);
  begin
    FEditProc(RecordId);
  end;

var
  Button: TWebButton;
begin
  if ARow = 0 then
    Exit;

  if WebDBTableControl1.Columns[ACol].Title = 'Actions' then
  begin
    RecordId := TCrudUtils.GetIdFromObject(
      PortalNachrichtenDataset.Connection.Model.DefaultSchema.FindEntityType(PortalNachrichtenDataset.EntitySetName),
      PortalNachrichtenDataset.CurrentData
    );
    Button := TWebButton.Create(nil);
    Button.Caption := 'Edit';
    Button.OnClick := @EditButtonClick;
    Button.ElementClassName := 'btn btn-outline btn-default btn-xs';
    Button.ParentElement := AElement.element;
    Button.WidthStyle := TSizeStyle.ssAuto;
    Button.HeightStyle := TSizeStyle.ssAuto;
  end;
end;

procedure TFViewPortalNachrichtenList.WebFormCreate(Sender: TObject);
begin
  FGridPlugin := TGridPlugin.Create(
    WebDBTableControl1,
    PortalNachrichtenDataset,
    lcPaginator,
    lbPaginationInfo
  );
  FGridPlugin.SetPageSize(StrToInt(cbPageSize.Text));
  FGridPlugin.SetFilterText(edSearch.Text);
  FGridPlugin.Load;
end;

end.
