unit View.PortalPfand.Edit;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls,

  Bcl.Rtti.Common, XData.Web.Client, Data.DB, WEBLib.CDS,
  WEBLib.DBCtrls, XData.Web.JsonDataset, XData.Web.Dataset, JS,

  App.Types, Crud.Utils, WEBLib.DB, WEBLib.Controls, WEBLib.ExtCtrls;

type
  TFViewPortalPfandEdit = class(TWebForm)
    pnlMessage: TWebPanel;
    lbMessage: TWebLabel;
    btCloseMessage: TWebButton;
    DataSource: TWebDatasource;
    btCancel: TWebButton;
    btSave: TWebButton;
    btDelete: TWebButton;
    lbPfandschein: TWebLabel;
    edPfandschein: TWebDBEdit;
    lbNummer: TWebLabel;
    edNummer: TWebDBEdit;
    lbStatus: TWebLabel;
    edStatus: TWebDBEdit;
    lbVersatz: TWebLabel;
    edVersatz: TWebDBEdit;
    lbVerfall: TWebLabel;
    edVerfall: TWebDBEdit;
    lbBeschreibung: TWebLabel;
    edBeschreibung: TWebDBEdit;
    lbDarlehen: TWebLabel;
    edDarlehen: TWebDBEdit;
    lbZinsen: TWebLabel;
    edZinsen: TWebDBEdit;
    lbGebuehren: TWebLabel;
    edGebuehren: TWebDBEdit;
    lbVerwahrgeld: TWebLabel;
    edVerwahrgeld: TWebDBEdit;
    lbSondergebuehr: TWebLabel;
    edSondergebuehr: TWebDBEdit;
    lbsngCreate: TWebLabel;
    edsngCreate: TWebDBEdit;
    lbsngCreateUser: TWebLabel;
    edsngCreateUser: TWebDBEdit;
    lbsngChange: TWebLabel;
    edsngChange: TWebDBEdit;
    lbsngChangeUser: TWebLabel;
    edsngChangeUser: TWebDBEdit;
    lbPortalKunde: TWebLabel;
    cbPortalKunde: TWebComboBox;
    XDataClientPortalPfandGet: TXDataWebClient;
    XDataClientPortalPfandDelete: TXDataWebClient;
    PortalPfandDataset: TXDataWebDataSet;
    PortalPfandDatasetPfandschein: TStringField;
    PortalPfandDatasetNummer: TStringField;
    PortalPfandDatasetStatus: TStringField;
    PortalPfandDatasetVersatz: TDateTimeField;
    PortalPfandDatasetVerfall: TDateTimeField;
    PortalPfandDatasetBeschreibung: TStringField;
    PortalPfandDatasetDarlehen: TFloatField;
    PortalPfandDatasetZinsen: TFloatField;
    PortalPfandDatasetGebuehren: TFloatField;
    PortalPfandDatasetVerwahrgeld: TFloatField;
    PortalPfandDatasetSondergebuehr: TFloatField;
    PortalPfandDatasetsngCreate: TDateTimeField;
    PortalPfandDatasetsngCreateUser: TStringField;
    PortalPfandDatasetsngChange: TDateTimeField;
    PortalPfandDatasetsngChangeUser: TStringField;
    PortalPfandDatasetPortalKunde: TXDataWebEntityField;
    PortalKundeDataset: TXDataWebDataSet;
    PortalKundeDatasetKundeID: TStringField;
    PortalKundeDatasetNummer: TStringField;
    PortalKundeDatasetVorname: TStringField;
    PortalKundeDatasetVorname2: TStringField;
    PortalKundeDatasetNachname: TStringField;
    PortalKundeDatasetFirma: TBooleanField;
    PortalKundeDatasetFirmenname: TStringField;
    PortalKundeDatasetUStID: TStringField;
    PortalKundeDatasetStrasse: TStringField;
    PortalKundeDatasetHausnummer: TStringField;
    PortalKundeDatasetZusatz: TStringField;
    PortalKundeDatasetPLZ: TStringField;
    PortalKundeDatasetOrt: TStringField;
    PortalKundeDatasetLand: TStringField;
    PortalKundeDatasetEmail: TStringField;
    PortalKundeDatasetTelefon1: TStringField;
    PortalKundeDatasetTelefon2: TStringField;
    PortalKundeDatasetAusweis: TStringField;
    PortalKundeDatasetAusweisTyp: TStringField;
    PortalKundeDatasetBehoerde: TStringField;
    PortalKundeDatasetHerkunft: TStringField;
    PortalKundeDatasetKontoinhaber: TStringField;
    PortalKundeDatasetIBAN: TStringField;
    PortalKundeDatasetBIC: TStringField;
    PortalKundeDatasetsngCreate: TDateTimeField;
    PortalKundeDatasetsngCreateUser: TStringField;
    PortalKundeDatasetsngChange: TDateTimeField;
    PortalKundeDatasetsngChangeUser: TStringField;
    procedure btCloseMessageClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure XDataClientPortalPfandGetLoad(Response: TXDataClientResponse);
    procedure XDataClientPortalPfandDeleteLoad(Response: TXDataClientResponse);
    procedure XDataClientPortalPfandDeleteError(Error: TXDataClientError);
    procedure PortalPfandDatasetAfterApplyUpdates(Sender: TDataSet;
      Info: TResolveResults);
    procedure WebFormCreate(Sender: TObject);
    procedure PortalKundeDatasetAfterOpen(DataSet: TDataSet);
  private
    FId: JSValue;
    FShowListProc: TListProc;
    procedure InsertEntity;
    procedure LoadEntity;
    procedure ShowNotification(Notification: string);
    procedure HiddenNotification;
    class function InternalCreateForm(AElementID: string;
      AShowListProc: TListProc; AInserting: Boolean; AId: JSValue): TWebForm; overload;
  protected
    FInserting: Boolean;
  public
    class function CreateForm(AElementID: string;
      AShowListProc: TListProc; AId: JSValue): TWebForm; overload;
  end;

var
  FViewPortalPfandEdit: TFViewPortalPfandEdit;

implementation

uses
  ConnectionModule;

{$R *.dfm}

{ TFViewPortalPfandEdit }

procedure TFViewPortalPfandEdit.btSaveClick(Sender: TObject);
begin
  if PortalPfandDataset.State in dsEditModes then
  begin
        PortalPfandDatasetPortalKunde.Value := cbPortalKunde.Items.Objects[cbPortalKunde.ItemIndex];
    PortalPfandDataset.Post;
    PortalPfandDataset.ApplyUpdates;
  end
  else
    FShowListProc;
end;

procedure TFViewPortalPfandEdit.btDeleteClick(Sender: TObject);
begin
  if PortalPfandDataset.State in dsEditModes then
    PortalPfandDataset.Post;
  XDataClientPortalPfandDelete.Delete(PortalPfandDataset.EntitySetName,
    TJSObject(PortalPfandDataset.CurrentData));
end;


class function TFViewPortalPfandEdit.CreateForm(AElementID: string;
  AShowListProc: TListProc; AId: JSValue): TWebForm;
var
  Inserting: Boolean;
begin
  Inserting := isNull(AId);
  Result := InternalCreateForm(AElementID, AShowListProc, Inserting, AId);
end;

procedure TFViewPortalPfandEdit.HiddenNotification;
begin
  pnlMessage.ElementHandle.hidden := True;
end;

procedure TFViewPortalPfandEdit.InsertEntity;
begin
  PortalPfandDataset.Close;
  PortalPfandDataset.SetJsonData('{}');
  PortalPfandDataset.Open;
  PortalPfandDataset.Insert;
  TCrudUtils.LoadAssociationDataset(PortalKundeDataset, 'Nummer');
end;

class function TFViewPortalPfandEdit.InternalCreateForm(AElementID: string;
  AShowListProc: TListProc; AInserting: Boolean; AId: JSValue): TWebForm;

  procedure AfterCreate(AForm: TObject);
  begin
    TFViewPortalPfandEdit(AForm).FInserting := AInserting;
    TFViewPortalPfandEdit(AForm).FId := AId;
    TFViewPortalPfandEdit(AForm).FShowListProc := AShowListProc;
    if AInserting then
      TFViewPortalPfandEdit(AForm).InsertEntity
    else
      TFViewPortalPfandEdit(AForm).LoadEntity;
    TFViewPortalPfandEdit(AForm).btDelete.Enabled := not AInserting;
  end;

begin
  Application.CreateForm(TFViewPortalPfandEdit, AElementID, Result, @AfterCreate);
end;

procedure TFViewPortalPfandEdit.LoadEntity;
var
  QueryString: string;
begin
  QueryString := TCrudUtils.GetEntityGetQueryString(
    PortalPfandDataset.Connection.Model.DefaultSchema.FindEntityType(
      PortalPfandDataset.EntitySetName
    )
  );
  XDataClientPortalPfandGet.Get(PortalPfandDataset.EntitySetName, QueryString, FId);
end;

procedure TFViewPortalPfandEdit.ShowNotification(Notification: string);
begin
  lbMessage.Caption := Notification;
  pnlMessage.ElementHandle.hidden := False;
end;

procedure TFViewPortalPfandEdit.btCloseMessageClick(Sender: TObject);
begin
  HiddenNotification;
end;

procedure TFViewPortalPfandEdit.WebFormCreate(Sender: TObject);
begin
  HiddenNotification;
end;

procedure TFViewPortalPfandEdit.XDataClientPortalPfandGetLoad(Response: TXDataClientResponse);
begin
  PortalPfandDataset.Close;
  PortalPfandDataset.SetJsonData(Response.Result);
  PortalPfandDataset.Open;
  
  PortalPfandDataset.Edit;  
  TCrudUtils.LoadAssociationDataset(PortalKundeDataset, 'Nummer');
end;

procedure TFViewPortalPfandEdit.XDataClientPortalPfandDeleteError(
  Error: TXDataClientError);
begin
  ShowNotification(Error.ErrorMessage);
end;

procedure TFViewPortalPfandEdit.XDataClientPortalPfandDeleteLoad(
  Response: TXDataClientResponse);
begin
  FShowListProc;
end;

procedure TFViewPortalPfandEdit.PortalPfandDatasetAfterApplyUpdates(Sender: TDataSet;
  Info: TResolveResults);
var
  I: integer;
  ResolveInfo: TResolveInfo;
begin
  for I := 0 to Length(Info.Records) - 1 do
  begin
    ResolveInfo := Info.Records[I];
//    if ResolveInfo.ResolveStatus = TResolveStatus.rsResolveFailed then
    if ResolveInfo.Error <> '' then
    begin
      ShowNotification(ResolveInfo.Error);
      Exit;
    end;
  end;
  FShowListProc;
end;

procedure TFViewPortalPfandEdit.btCancelClick(Sender: TObject);
begin
  FShowListProc;
end;

procedure TFViewPortalPfandEdit.PortalKundeDatasetAfterOpen(DataSet: TDataSet);
begin
  TCrudUtils.PopulateAssociationCombobox(cbPortalKunde,
    TXDataWebDataSet(DataSet), 'Nummer');

  if FInserting then
    cbPortalKunde.ItemIndex := -1
  else
  begin
    TCrudUtils.SelectAssociationItem(cbPortalKunde, PortalPfandDatasetPortalKunde);
  end;
end;

end.
