unit View.PortalPfand.List;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.Controls, Vcl.StdCtrls, Math,

  WEBLib.StdCtrls, Web, JS, WEBLib.Lists,

  App.Types, WEBLib.Controls, WEBLib.Grids, Data.DB,
  XData.Web.Dataset, WEBLib.DBCtrls, WEBLib.DB, WEBLib.ExtCtrls,

  XData.Web.JsonDataset,

  Grid.Plugins,
  Crud.Utils;

type
  TFViewPortalPfandList = class(TWebForm)
    btNew: TWebButton;
    PortalPfandDataset: TXDataWebDataSet;
    PortalPfandDatasetPfandschein: TStringField;
    PortalPfandDatasetNummer: TStringField;
    PortalPfandDatasetStatus: TStringField;
    PortalPfandDatasetVersatz: TDateTimeField;
    PortalPfandDatasetVerfall: TDateTimeField;
    PortalPfandDatasetBeschreibung: TStringField;
    PortalPfandDatasetDarlehen: TFloatField;
    PortalPfandDatasetZinsen: TFloatField;
    PortalPfandDatasetGebuehren: TFloatField;
    PortalPfandDatasetVerwahrgeld: TFloatField;
    PortalPfandDatasetSondergebuehr: TFloatField;
    PortalPfandDatasetsngCreate: TDateTimeField;
    PortalPfandDatasetsngCreateUser: TStringField;
    PortalPfandDatasetsngChange: TDateTimeField;
    PortalPfandDatasetsngChangeUser: TStringField;
    PortalPfandDatasetPortalKunde: TXDataWebEntityField;
    PortalPfandDatasetPortalKundeNummer: TStringField;
    WebDBTableControl1: TWebDBTableControl;
    WebDataSource: TWebDataSource;
    cbPageSize: TWebComboBox;
    edSearch: TWebEdit;
    lbPaginationInfo: TWebLabel;
    lcPaginator: TWebListControl;
    procedure WebFormCreate(Sender: TObject);
    procedure btNewClick(Sender: TObject);
    procedure WebDBTableControl1GetCellChildren(Sender: TObject; ACol,
      ARow: Integer; AField: TField; AValue: string; AElement: TJSHTMLElementRecord);
    procedure cbPageSizeChange(Sender: TObject);
    procedure edSearchChange(Sender: TObject);
  private
    FEditProc: TEditProc;
    FGridPlugin: TGridPlugin;
  public
    class function CreateForm(AElementID: string; AShowEditProc: TEditProc): TWebForm;
  end;

var
  FViewPortalPfandList: TFViewPortalPfandList;

implementation

uses
  ConnectionModule;

{$R *.dfm}

{ TFViewPortalPfandList }

procedure TFViewPortalPfandList.cbPageSizeChange(Sender: TObject);
begin
  FGridPlugin.SetPageSize(StrToInt(cbPageSize.Text), True);
end;

class function TFViewPortalPfandList.CreateForm(AElementID: string;
  AShowEditProc: TEditProc): TWebForm;

  procedure AfterCreate(AForm: TObject);
  begin
    TFViewPortalPfandList(AForm).FEditProc := AShowEditProc;
  end;

begin
  Application.CreateForm(TFViewPortalPfandList, AElementID, Result, @AfterCreate);
end;

procedure TFViewPortalPfandList.edSearchChange(Sender: TObject);
begin
  FGridPlugin.SetFilterText(edSearch.Text, True);
end;

procedure TFViewPortalPfandList.btNewClick(Sender: TObject);
begin
  FEditProc( nil );
end;

procedure TFViewPortalPfandList.WebDBTableControl1GetCellChildren(Sender: TObject;
  ACol, ARow: Integer; AField: TField; AValue: string;
  AElement: TJSHTMLElementRecord);
var
  RecordId: JSValue;

  procedure EditButtonClick(Sender: TObject);
  begin
    FEditProc(RecordId);
  end;

var
  Button: TWebButton;
begin
  if ARow = 0 then
    Exit;

  if WebDBTableControl1.Columns[ACol].Title = 'Actions' then
  begin
    RecordId := TCrudUtils.GetIdFromObject(
      PortalPfandDataset.Connection.Model.DefaultSchema.FindEntityType(PortalPfandDataset.EntitySetName),
      PortalPfandDataset.CurrentData
    );
    Button := TWebButton.Create(nil);
    Button.Caption := 'Edit';
    Button.OnClick := @EditButtonClick;
    Button.ElementClassName := 'btn btn-outline btn-default btn-xs';
    Button.ParentElement := AElement.element;
    Button.WidthStyle := TSizeStyle.ssAuto;
    Button.HeightStyle := TSizeStyle.ssAuto;
  end;
end;

procedure TFViewPortalPfandList.WebFormCreate(Sender: TObject);
begin
  FGridPlugin := TGridPlugin.Create(
    WebDBTableControl1,
    PortalPfandDataset,
    lcPaginator,
    lbPaginationInfo
  );
  FGridPlugin.SetPageSize(StrToInt(cbPageSize.Text));
  FGridPlugin.SetFilterText(edSearch.Text);
  FGridPlugin.Load;
end;

end.
