unit View.PortalProtokoll.Edit;

interface

uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls,

  Bcl.Rtti.Common, XData.Web.Client, Data.DB, WEBLib.CDS,
  WEBLib.DBCtrls, XData.Web.JsonDataset, XData.Web.Dataset, JS,

  App.Types, Crud.Utils, WEBLib.DB, WEBLib.Controls, WEBLib.ExtCtrls;

type
  TFViewPortalProtokollEdit = class(TWebForm)
    pnlMessage: TWebPanel;
    lbMessage: TWebLabel;
    btCloseMessage: TWebButton;
    DataSource: TWebDatasource;
    btCancel: TWebButton;
    btSave: TWebButton;
    btDelete: TWebButton;
    lbProtokollID: TWebLabel;
    edProtokollID: TWebDBEdit;
    lbDatum: TWebLabel;
    edDatum: TWebDBEdit;
    lbWerte: TWebLabel;
    edWerte: TWebDBEdit;
    lbsngCreate: TWebLabel;
    edsngCreate: TWebDBEdit;
    lbsngCreateUser: TWebLabel;
    edsngCreateUser: TWebDBEdit;
    lbsngChange: TWebLabel;
    edsngChange: TWebDBEdit;
    lbsngChangeUser: TWebLabel;
    edsngChangeUser: TWebDBEdit;
    lbPersonID: TWebLabel;
    cbPersonID: TWebComboBox;
    XDataClientPortalProtokollGet: TXDataWebClient;
    XDataClientPortalProtokollDelete: TXDataWebClient;
    PortalProtokollDataset: TXDataWebDataSet;
    PortalProtokollDatasetProtokollID: TStringField;
    PortalProtokollDatasetDatum: TDateTimeField;
    PortalProtokollDatasetWerte: TStringField;
    PortalProtokollDatasetsngCreate: TDateTimeField;
    PortalProtokollDatasetsngCreateUser: TStringField;
    PortalProtokollDatasetsngChange: TDateTimeField;
    PortalProtokollDatasetsngChangeUser: TStringField;
    PortalProtokollDatasetPersonID: TXDataWebEntityField;
    PersonIDDataset: TXDataWebDataSet;
    PersonIDDatasetKundeID: TStringField;
    PersonIDDatasetNummer: TStringField;
    PersonIDDatasetVorname: TStringField;
    PersonIDDatasetVorname2: TStringField;
    PersonIDDatasetNachname: TStringField;
    PersonIDDatasetFirma: TBooleanField;
    PersonIDDatasetFirmenname: TStringField;
    PersonIDDatasetUStID: TStringField;
    PersonIDDatasetStrasse: TStringField;
    PersonIDDatasetHausnummer: TStringField;
    PersonIDDatasetZusatz: TStringField;
    PersonIDDatasetPLZ: TStringField;
    PersonIDDatasetOrt: TStringField;
    PersonIDDatasetLand: TStringField;
    PersonIDDatasetEmail: TStringField;
    PersonIDDatasetTelefon1: TStringField;
    PersonIDDatasetTelefon2: TStringField;
    PersonIDDatasetAusweis: TStringField;
    PersonIDDatasetAusweisTyp: TStringField;
    PersonIDDatasetBehoerde: TStringField;
    PersonIDDatasetHerkunft: TStringField;
    PersonIDDatasetKontoinhaber: TStringField;
    PersonIDDatasetIBAN: TStringField;
    PersonIDDatasetBIC: TStringField;
    PersonIDDatasetsngCreate: TDateTimeField;
    PersonIDDatasetsngCreateUser: TStringField;
    PersonIDDatasetsngChange: TDateTimeField;
    PersonIDDatasetsngChangeUser: TStringField;
    procedure btCloseMessageClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure XDataClientPortalProtokollGetLoad(Response: TXDataClientResponse);
    procedure XDataClientPortalProtokollDeleteLoad(Response: TXDataClientResponse);
    procedure XDataClientPortalProtokollDeleteError(Error: TXDataClientError);
    procedure PortalProtokollDatasetAfterApplyUpdates(Sender: TDataSet;
      Info: TResolveResults);
    procedure WebFormCreate(Sender: TObject);
    procedure PersonIDDatasetAfterOpen(DataSet: TDataSet);
  private
    FId: JSValue;
    FShowListProc: TListProc;
    procedure InsertEntity;
    procedure LoadEntity;
    procedure ShowNotification(Notification: string);
    procedure HiddenNotification;
    class function InternalCreateForm(AElementID: string;
      AShowListProc: TListProc; AInserting: Boolean; AId: JSValue): TWebForm; overload;
  protected
    FInserting: Boolean;
  public
    class function CreateForm(AElementID: string;
      AShowListProc: TListProc; AId: JSValue): TWebForm; overload;
  end;

var
  FViewPortalProtokollEdit: TFViewPortalProtokollEdit;

implementation

uses
  ConnectionModule;

{$R *.dfm}

{ TFViewPortalProtokollEdit }

procedure TFViewPortalProtokollEdit.btSaveClick(Sender: TObject);
begin
  if PortalProtokollDataset.State in dsEditModes then
  begin
        PortalProtokollDatasetPersonID.Value := cbPersonID.Items.Objects[cbPersonID.ItemIndex];
    PortalProtokollDataset.Post;
    PortalProtokollDataset.ApplyUpdates;
  end
  else
    FShowListProc;
end;

procedure TFViewPortalProtokollEdit.btDeleteClick(Sender: TObject);
begin
  if PortalProtokollDataset.State in dsEditModes then
    PortalProtokollDataset.Post;
  XDataClientPortalProtokollDelete.Delete(PortalProtokollDataset.EntitySetName,
    TJSObject(PortalProtokollDataset.CurrentData));
end;


class function TFViewPortalProtokollEdit.CreateForm(AElementID: string;
  AShowListProc: TListProc; AId: JSValue): TWebForm;
var
  Inserting: Boolean;
begin
  Inserting := isNull(AId);
  Result := InternalCreateForm(AElementID, AShowListProc, Inserting, AId);
end;

procedure TFViewPortalProtokollEdit.HiddenNotification;
begin
  pnlMessage.ElementHandle.hidden := True;
end;

procedure TFViewPortalProtokollEdit.InsertEntity;
begin
  PortalProtokollDataset.Close;
  PortalProtokollDataset.SetJsonData('{}');
  PortalProtokollDataset.Open;
  PortalProtokollDataset.Insert;
  TCrudUtils.LoadAssociationDataset(PersonIDDataset, 'Nummer');
end;

class function TFViewPortalProtokollEdit.InternalCreateForm(AElementID: string;
  AShowListProc: TListProc; AInserting: Boolean; AId: JSValue): TWebForm;

  procedure AfterCreate(AForm: TObject);
  begin
    TFViewPortalProtokollEdit(AForm).FInserting := AInserting;
    TFViewPortalProtokollEdit(AForm).FId := AId;
    TFViewPortalProtokollEdit(AForm).FShowListProc := AShowListProc;
    if AInserting then
      TFViewPortalProtokollEdit(AForm).InsertEntity
    else
      TFViewPortalProtokollEdit(AForm).LoadEntity;
    TFViewPortalProtokollEdit(AForm).btDelete.Enabled := not AInserting;
  end;

begin
  Application.CreateForm(TFViewPortalProtokollEdit, AElementID, Result, @AfterCreate);
end;

procedure TFViewPortalProtokollEdit.LoadEntity;
var
  QueryString: string;
begin
  QueryString := TCrudUtils.GetEntityGetQueryString(
    PortalProtokollDataset.Connection.Model.DefaultSchema.FindEntityType(
      PortalProtokollDataset.EntitySetName
    )
  );
  XDataClientPortalProtokollGet.Get(PortalProtokollDataset.EntitySetName, QueryString, FId);
end;

procedure TFViewPortalProtokollEdit.ShowNotification(Notification: string);
begin
  lbMessage.Caption := Notification;
  pnlMessage.ElementHandle.hidden := False;
end;

procedure TFViewPortalProtokollEdit.btCloseMessageClick(Sender: TObject);
begin
  HiddenNotification;
end;

procedure TFViewPortalProtokollEdit.WebFormCreate(Sender: TObject);
begin
  HiddenNotification;
end;

procedure TFViewPortalProtokollEdit.XDataClientPortalProtokollGetLoad(Response: TXDataClientResponse);
begin
  PortalProtokollDataset.Close;
  PortalProtokollDataset.SetJsonData(Response.Result);
  PortalProtokollDataset.Open;
  
  PortalProtokollDataset.Edit;  
  TCrudUtils.LoadAssociationDataset(PersonIDDataset, 'Nummer');
end;

procedure TFViewPortalProtokollEdit.XDataClientPortalProtokollDeleteError(
  Error: TXDataClientError);
begin
  ShowNotification(Error.ErrorMessage);
end;

procedure TFViewPortalProtokollEdit.XDataClientPortalProtokollDeleteLoad(
  Response: TXDataClientResponse);
begin
  FShowListProc;
end;

procedure TFViewPortalProtokollEdit.PortalProtokollDatasetAfterApplyUpdates(Sender: TDataSet;
  Info: TResolveResults);
var
  I: integer;
  ResolveInfo: TResolveInfo;
begin
  for I := 0 to Length(Info.Records) - 1 do
  begin
    ResolveInfo := Info.Records[I];
//    if ResolveInfo.ResolveStatus = TResolveStatus.rsResolveFailed then
    if ResolveInfo.Error <> '' then
    begin
      ShowNotification(ResolveInfo.Error);
      Exit;
    end;
  end;
  FShowListProc;
end;

procedure TFViewPortalProtokollEdit.btCancelClick(Sender: TObject);
begin
  FShowListProc;
end;

procedure TFViewPortalProtokollEdit.PersonIDDatasetAfterOpen(DataSet: TDataSet);
begin
  TCrudUtils.PopulateAssociationCombobox(cbPersonID,
    TXDataWebDataSet(DataSet), 'Nummer');

  if FInserting then
    cbPersonID.ItemIndex := -1
  else
  begin
    TCrudUtils.SelectAssociationItem(cbPersonID, PortalProtokollDatasetPersonID);
  end;
end;

end.
